# -*- coding: utf8 -*-

import sys

import infoauth
import tweepy

import web_scrapper
import informer


def login_twitter():
    auth = infoauth.load("twitter_auth.pkl")
    consumer_token, consumer_secret, access_token, access_secret = auth

    auth = tweepy.OAuthHandler(consumer_token, consumer_secret)
    auth.set_access_token(access_token, access_secret)
    api = tweepy.API(auth)
    return api
#api.update_status(msg)
#api.send_direct_message(screen_name="facundobatista", text="Foobar")

TORNEOS = (1536,)

def tour_info(tid, for_real):
    if for_real:
        api = login_twitter()
    for ttype in ('ms', 'md'):
        t = web_scrapper.Tournament(tid, ttype)
        city, player_info = t.calculate()

        print "\n%s:" % (city,)
        for player_name, seq in player_info:
            print " ", player_name, seq

        inf = informer.Informer()
        report = inf.report(city, ttype, player_info)
        if for_real:
            assert len(report) < 140
            if len(report) < 130:
                report += u" #tenis"
            api.update_status(t)
        else:
            print report



def live_scores(for_real):
    if for_real:
        api = login_twitter()
        to_get = 2
        dry = False
    else:
        to_get = 10
        dry = True

    ls = web_scrapper.LiveScores()
    matches = ls.get(to_get, dry)
    for m in matches:
        t = informer.format_live_news(*m)
        if for_real:
            assert len(t) < 140
            if len(t) < 130:
                t += u" #tenis"
            api.update_status(t)
        else:
            print t


def from_cmdline(msg, for_real):
    assert len(msg) < 140
    if for_real:
        api = login_twitter()
        api.update_status(msg)
    else:
        print msg


if __name__ == "__main__":
    def quit():
        print 'Usage tuitero.py {--real|--show} '\
              '{--live|--tour <id>|--msg "<msg>"}'
        exit()

    if len(sys.argv) not in (3, 4):
        quit()

    opt = sys.argv[1]
    if opt == '--real':
        for_real = True
    elif opt == '--show':
        for_real = False
    else:
        quit()

    opt = sys.argv[2]
    if opt == '--live':
        live_scores(for_real)
    elif opt == '--tour':
        tour_info(int(sys.argv[3]), for_real)
    elif opt == '--msg':
        msg = sys.argv[3].decode("utf8")
        from_cmdline(msg, for_real)
    else:
        quit()
